"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var Rx_1 = require("rxjs/Rx");
require("rxjs/add/operator/startWith");
var core_1 = require("@angular/core");
var DraggableDirective = (function () {
    function DraggableDirective(el, renderer) {
        this.el = el;
        this.renderer = renderer;
        // You can now set draggable on and off by just assigning it a value
        // I dont quite understand how it was working without this
        this.draggable = true;
        this.dragging = false;
        this.Δx = 0;
        this.Δy = 0;
        this.mustBePosition = ['absolute', 'fixed', 'relative'];
    }
    DraggableDirective.prototype.onMouseup = function (event) {
        this.Δx = 0;
        this.Δy = 0;
        this.dragging = false;
        this.el.nativeElement.style.pointerEvents = 'all';
        if (!this.drag$.closed) {
            this.drag$.unsubscribe();
        }
    };
    DraggableDirective.prototype.onMousedown = function (event) {
        var _this = this;
        if (this.draggable) {
            // event.preventDefault();
            this.Δx = event.x - this.el.nativeElement.offsetLeft;
            this.Δy = event.y - this.el.nativeElement.offsetTop;
            this.dragging = true;
            var end = Rx_1.Observable.fromEvent(document, "mouseup")
                .subscribe(function (ev) {
                _this.onMouseup(ev);
            });
            // The skip allows to avoid staggering in case of a single click. It's not super-elegant cause we are still building and destroying the sub.
            this.drag$ = Rx_1.Observable.fromEvent(document, "mousemove")
                .do(function (event) { return _this.el.nativeElement.style.pointerEvents = 'none'; })
                .skip(1)
                .subscribe(function (ev) {
                _this.doTranslation(ev.x, ev.y);
            });
        }
    };
    // @HostListener('mousemove', ['$event'])
    // onMousemove(event: MouseEvent) {
    // }
    DraggableDirective.prototype.ngAfterViewInit = function () {
        try {
            // Gonna silence this till it's more consistent in detecting the position
            if (this.mustBePosition.indexOf(this.el.nativeElement.style.position) === -1) {
            }
        }
        catch (ex) {
            console.error(ex);
        }
        // this.renderer.setElementAttribute(this.el.nativeElement, 'draggable', 'true');
    };
    DraggableDirective.prototype.ngOnDestroy = function () {
        // this.renderer.setElementAttribute(this.el.nativeElement, 'draggable', 'false');
    };
    DraggableDirective.prototype.doTranslation = function (x, y) {
        if (!x || !y) {
            return;
        }
        this.renderer.setElementStyle(this.el.nativeElement, 'top', (y - this.Δy) + 'px');
        this.renderer.setElementStyle(this.el.nativeElement, 'left', (x - this.Δx) + 'px');
    };
    return DraggableDirective;
}());
__decorate([
    core_1.Input("draggable"),
    __metadata("design:type", Boolean)
], DraggableDirective.prototype, "draggable", void 0);
__decorate([
    core_1.HostListener('mousedown', ['$event']),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [MouseEvent]),
    __metadata("design:returntype", void 0)
], DraggableDirective.prototype, "onMousedown", null);
DraggableDirective = __decorate([
    core_1.Directive({
        selector: '[draggable]'
    }),
    __metadata("design:paramtypes", [core_1.ElementRef, core_1.Renderer])
], DraggableDirective);
exports.DraggableDirective = DraggableDirective;
//# sourceMappingURL=draggable.directive.js.map